package com.tashow.cloud.product.service.impl;

import com.tashow.cloud.productapi.api.product.dto.ProductOrderLimitDO;
import com.tashow.cloud.product.mapper.ProductOrderLimitMapper;
import com.tashow.cloud.product.service.ProductOrderLimitService;
import com.tashow.cloud.productapi.api.product.vo.productorderlimit.ProductOrderLimitPageReqVO;
import com.tashow.cloud.productapi.api.product.vo.productorderlimit.ProductOrderLimitSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;
import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 商品接单上限设置 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class ProductOrderLimitServiceImpl implements ProductOrderLimitService {

    @Resource
    private ProductOrderLimitMapper productOrderLimitMapper;

    @Override
    public Long createProductOrderLimit(ProductOrderLimitSaveReqVO createReqVO) {
        // 插入
        ProductOrderLimitDO productOrderLimit = BeanUtils.toBean(createReqVO, ProductOrderLimitDO.class);
        productOrderLimitMapper.insert(productOrderLimit);
        // 返回
        return productOrderLimit.getId();
    }

    @Override
    public void updateProductOrderLimit(ProductOrderLimitSaveReqVO updateReqVO) {
        // 校验存在
        validateProductOrderLimitExists(updateReqVO.getId());
        // 更新
        ProductOrderLimitDO updateObj = BeanUtils.toBean(updateReqVO, ProductOrderLimitDO.class);
        productOrderLimitMapper.updateById(updateObj);
    }

    @Override
    public void deleteProductOrderLimit(Long id) {
        // 校验存在
        validateProductOrderLimitExists(id);
        // 删除
        productOrderLimitMapper.deleteById(id);
    }

    private void validateProductOrderLimitExists(Long id) {
        if (productOrderLimitMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.PRODUCT_ORDER_LIMIT_NOT_EXISTS);
        }
    }

    @Override
    public ProductOrderLimitDO getProductOrderLimit(Long id) {
        return productOrderLimitMapper.selectById(id);
    }

    @Override
    public PageResult<ProductOrderLimitDO> getProductOrderLimitPage(ProductOrderLimitPageReqVO pageReqVO) {
        return null;
    }

}